import java.awt.*;

public class Creature extends Lifeform
{
 public Creature()
 {
   m_brain = new CreatureBrain(this);
 }
 
 public void Update(SimulationMgr simmgr)
 { 
   m_SimMgr = simmgr;
   
   super.Update(simmgr);   
   
   m_brain.Think();     
 }
 
 public void Move()
 {
   Point pos = GetPosition();     
   //SetPosition();
   switch(DirectionFacing)
   {
   case 1:
     {
       pos.x--;
       pos.y++;
     }
     break;
   case 2:
     {
     pos.y++;
     }
     break;
   case 3:
     {
       pos.x++;
       pos.y++;
     }
     break;
   case 4:
     {
       pos.x--;
     }
     break;
   case 6:
     {
       pos.x++;
     }
     break;
   case 7:
     {
       pos.x++;
       pos.y--;
     }
     break;
   case 8:
     {
       pos.y--;
     }
     break;     
   case 9:
     {
       pos.x++;
       pos.y--;
     }
     break;     
   default:
     {
       System.out.println("DEFAULT "+DirectionFacing);
     }
     break;
   }
   
   SetPosition(pos.x, pos.y);
 }
 
 public Point GetNextPos()
 {
   Point pos = GetPosition();     
   //SetPosition();
   switch(DirectionFacing)
   {
   case 1:
     {
       pos.x--;
       pos.y++;
     }
     break;
   case 2:
     {
     pos.y++;
     }
     break;
   case 3:
     {
       pos.x++;
       pos.y++;
     }
     break;
   case 4:
     {
       pos.x--;
     }
     break;
   case 6:
     {
       pos.x++;
     }
     break;
   case 7:
     {
       pos.x++;
       pos.y--;
     }
     break;
   case 8:
     {
       pos.y--;
     }
     break;     
   case 9:
     {
       pos.x++;
       pos.y--;
     }
     break;     
   default:
     {
       System.out.println("next pos DEFAULT "+DirectionFacing);
     }     
     break;
   }   
   
   return pos;
 }
 
 public void PickNewDir()
 {
   int newdir = (m_SimMgr.R.nextInt() % 9); 
   if(newdir < 0) newdir = -newdir;
   
   newdir++;
   
   if(newdir == 5)return;
   
   DirectionFacing = newdir;
   
 }
 
 public void SetSimMgr(SimulationMgr simmgr)
 {
   m_SimMgr = simmgr;
 }
 
 CreatureBrain m_brain;
 
 SimulationMgr m_SimMgr;
 
 int DirectionFacing = 8;
 //
 //7 8 9
 //4 - 6
 //1 2 3
 //
 
 
 
 //creatures needs
 //food
 //water
 //shelter

 //
 // The creatures first goal should be to find water, then setup shelter
 //
 
}
