import java.awt.*;

public class CreatureBrain extends Brain
{
  
  public CreatureBrain(Creature self)
  {
    m_Self = self; 
    
    //HACK: get real size from SimMgr
    map = new Color[300][300];
    
    for (int i = 0;i<300; i++)
    {
      for (int j = 0;j<300; j++)
      { 
  	    map[j][i] = Color.black;
      }
    }
  }
  
  public void Think()
  {
    //evaluate needs
    //do an action based on those needs
    
    
    if(m_Self.thirst > 10)  
    {
      if(m_Self.thirst == 11)
      System.out.println("I need water");
      LookForWater();
    }
    else
      Explore();
    
    
    
    //Explore();
  
  }
  
  public Color[][] GetMap()
  {
    return map;
  }  
    
  
  public void Explore()
  {
    //look around for places not yet discovered
      
    Point pos = m_Self.GetNextPos();//m_Self.GetPosition();       
    if(!m_Self.m_SimMgr.IsValid(pos.x, pos.y))
    {
      m_Self.PickNewDir();
      return;
    }
    
    Color type = m_Self.m_SimMgr.GetMapPixel(pos.x, pos.y);
    if(type.getBlue() >250)
    {
      //System.out.println("found water, trying to move elsewhere");
      m_Self.PickNewDir();
      return;    
    }
    
    m_Self.Move();
    
    //Gather information about the surrounding area.
    for(int i = 0; i < 3; i++)
    {
      for(int j = 0; j < 3; j++)
      {
        if(!m_Self.m_SimMgr.IsValid(pos.x -1 +j, pos.y - 1 +i))
        {
          continue;
        }
        
        Color area = m_Self.m_SimMgr.GetMapPixel(pos.x -1 +j, pos.y - 1 +i);               
        map[(pos.x -1 +j)][(pos.y - 1 +i)] = area;
      }
    }     
  
  }
  
  public void LookForWater()
  {
    boolean found_water = false;
    
    //do I know where there is any water?
    
    //if so how far away is it? 
        //should i look for closer water?
    
    //
    //if no known water exists look for it.
    //
    Point pos = m_Self.GetPosition();       
    for(int i = 0; i < 3; i++)
    {
      for(int j = 0; j < 3; j++)
      {
        if(!m_Self.m_SimMgr.IsValid(pos.x -1 +j, pos.y - 1 +i))
        {
          continue;
        }
           
        Color area = m_Self.m_SimMgr.GetMapPixel(pos.x -1 +j, pos.y - 1 +i);        
        
        if(area != Color.black)
        {
          map[(pos.x -1 +j)][(pos.y - 1 +i)] = area;
        }
        if(area.getBlue() > 200)
        {
          found_water = true;
        }
      }
    }            
    
    if(found_water)
    {
      System.out.println("I am no longer thirsty...");
      m_Self.thirst = -45;
    }
    
    if(!found_water)
    {
      //need to move to a different location I haven't been
      Explore();
    }
    
    
  }
  
  Creature m_Self; 
  Color map[][]; // <- this is the creature's knowledge of what the map looks like.
}
