import java.util.*;
import java.awt.*;

public class SimulationMgr extends Thread
{
	public SimulationMgr()
	{
		Init();
		m_lifeforms = new Vector(0,1);	
		m_SimCanvas = new SimulationCanvas(sizex, sizey, map);
    
    m_TestCanvas = new SimulationCanvas(sizex, sizey, null);
	}
	
	public void Init()
	{
	  CreateStatic();
    /*
    MipMap(5);
    SharpenBlue();
    SharpenGreen();    
    MipMap(5);
    SharpenBlue();
    SharpenGreen();    
    MipMap(5);
    SharpenBlue();
    SharpenGreen();    
    */
    
	}
	
	public void run()
	{
    running = true;
    CreateLifeForms();
    
	 while(!done)
	 {
	  try
	  {
     //System.out.println("Simulation Update: "+updates);
 	   UpdateLifeforms();	
	   sleep(250); //updates map 4times  per second
     repaint();
     updates++;
	  }
	  catch(Exception e)
	  {
	   System.out.println("(SimulationMgr)ERROR: "+e);
	  }
		 
	 }
	}
	
	public void AddLifeForm(Lifeform val)
	{
		m_lifeforms.addElement(val);
	}
	
	public void UpdateLifeforms()
	{
		for(int i = 0; i < m_lifeforms.size(); i++ )
		{
			Lifeform object = (Lifeform)m_lifeforms.elementAt(i);
			object.Update(this);
		}		
	}	

	public SimulationCanvas GetSimulationCanvas()
	{
		return m_SimCanvas;
	}
  
  public SimulationCanvas GetTestCanvas()
  {
    return m_TestCanvas;
  }
  
  
  public void ZoomIn()
  {
    m_SimCanvas.ZoomIn();
  }

  public void ZoomOut()
  {
    m_SimCanvas.ZoomOut();
  }  
	
	public void repaint()
	{
    //sim = map;
   for(int i = 0; i < sizex; i++)
	 {
	  for(int j = 0; j < sizey; j++)
    {
      sim[j][i] = map[j][i];
    }
   }
    
    if(running)
    {
     RepaintSim();
     m_TestCanvas.SetMap( ((Creature)m_lifeforms.elementAt(0)).m_brain.GetMap() );
     m_TestCanvas.refresh();
    }
    
    m_SimCanvas.SetMap(sim);
		m_SimCanvas.refresh();
	}
  
  public void RepaintSim()
  {
		for(int i = 0; i < m_lifeforms.size(); i++ )
		{
			Lifeform object = (Lifeform)m_lifeforms.elementAt(i);
			//object.Update();
      Point pos = object.GetPosition();
      sim[pos.x][pos.y] = Color.black;
		}	    
  }  
  
  //
  //
  //
  //  
  
  //temp function to place one creature in the world
  public void CreateLifeForms()
  {
    //for(int i = 0; i < 100; i++)
    //{
      Creature c = new Creature();
      c.SetSimMgr(this);
      c.PickNewDir();
      
      int posx = 0, posy = 0;
      int green = 0;
      //find a good spot to stick it.
      while(green < 250)
      {
        posx = R.nextInt() % sizex;
        if(posx < 0) posx = -posx;
        posy = R.nextInt() % sizey;  
        if(posy < 0) posy = -posy;           
        green = map[posx][posy].getGreen();   
      }    
      
      c.SetPosition(posx, posy);      
      AddLifeForm(c);
    //}
    
  }
  
  
  //---------------------------------------------
  //
  //   Image Manipulation Functions
  //
  //---------------------------------------------
  
  //currently lifeforms are only allowed to travel on land. (green)
  public boolean IsValid(int x, int y)
  {
        if((x > 0)&&(y > 0) && (x < sizex)&&(y < sizey))
        {
          //if(GetMapPixel(x,y).getGreen() > 250 )
          return true;
          //else 
//            return false;
        }
        else
          return false;
    
  }  
  
  public Color GetMapPixel(int x, int y)
  {
    if((x > 0)&&(y > 0) && (x < sizex)&&(y < sizey))
    return map[x][y];
    
    else return Color.black; //black is known as void to the lifeform
  }
  
  public void CreateNewWorld()
  {
    CreateStatic();
    MipMap(5);
    SharpenBlue();
    SharpenGreen();
    MipMap(5);
    SharpenBlue();
    SharpenGreen();
    MipMap(5);
    SharpenBlue();
    SharpenGreen();
    MipMap(5);
    SharpenBlue();
    SharpenGreen();    
  }
  
	public void CreateStatic()
	{
	 for(int i = 0; i < sizex; i++)
	 {
	  for(int j = 0; j < sizey; j++)
      {
       //Color color
       int r, g, b;
       r = R.nextInt() % 256;   
       if(r < 0) r = -r;
       
       g = R.nextInt() % 256;
       if(g < 0) g = -g;   
       
       b = R.nextInt() % 256;
       if(b < 0) b = -b;
       map[j][i] = new Color(r, g, b);
      }
     }		
	}
  
  public void MipMap(int times)
  {
    for(int t = 0; t < times; t++)
    {
      for(int i = 0; i < sizex - 1; i++)
      {
        for(int j = 0; j < sizey - 1; j++)
        {
          int r, g ,b;
    	
      	  r = map[j][i].getRed();
	        r += map[j+1][i].getRed();
	        r += map[j][i+1].getRed();
	        r += map[j+1][i+1].getRed();
	        r = r/4;
  
	        g = map[j][i].getGreen();
	        g += map[j+1][i].getGreen();
	        g += map[j][i+1].getGreen();
	        g += map[j+1][i+1].getGreen();
	        g = g/4;
  
	        b = map[j][i].getBlue();
	        b += map[j+1][i].getBlue();
  	      b += map[j][i+1].getBlue();
	        b += map[j+1][i+1].getBlue();
	        b = b/4;
  	
	        map[j][i] = new Color(r, g, b);
	        map[j+1][i] = new Color(r, g, b);
	        map[j][i+1] = new Color(r, g, b);
	        map[j+1][i+1] = new Color(r, g, b);			
        }
      }
    }
    m_SimCanvas.SetMap(map);
  }
  
public void SharpenRed()
{
  for(int i = 0; i < sizex; i++)
 {
  for(int j = 0; j < sizey; j++)
  {
    int r, g ,b;
	r = map[j][i].getRed();
	g = map[j][i].getGreen();
	b = map[j][i].getBlue();
	
	if((r > g)&&(r > b))
    {
	 map[j][i] = new Color(255, 0, 0);
	}
  }
 }
 repaint();
}

public void SharpenGreen()
{
  for(int i = 0; i < sizex; i++)
 {
  for(int j = 0; j < sizey; j++)
  {
    int r, g ,b;
	r = map[j][i].getRed();
	g = map[j][i].getGreen();
	b = map[j][i].getBlue();
	
	if((g > r)&&(g > b))
    {
	 map[j][i] = new Color(0, 255, 0);
	}
  }
 }
 repaint();
}

public void SharpenBlue()
{
  for(int i = 0; i < sizex; i++)
 {
  for(int j = 0; j < sizey; j++)
  {
    int r, g ,b;
	r = map[j][i].getRed();
	g = map[j][i].getGreen();
	b = map[j][i].getBlue();
	
	if((b > r)&&(b > g))
    {
	 //if((R.nextInt() % 200+200) > 100 )
	  map[j][i] = new Color(0, 0, 255);
	 //else
	  //picture[j][i] = new Color(r, g, 0);	 
	}
  }
 }
 repaint();
}  
	  
	
	boolean running = false;
	boolean done = false;
	Vector m_lifeforms;
	SimulationCanvas m_SimCanvas;
  
  SimulationCanvas m_TestCanvas;
	int sizex = 300;
	int sizey = 300;
  long updates = 0;
	
	Color map[][] = new Color[sizex][sizey];
  
  Color sim[][] = new Color[sizex][sizey];
	Random R = new Random();
}


